#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n, unsigned int k) : n(n){
    a = container(n, element(n));
    b = container();
    less = ordering();
  }
  void primal() {
    random_sequence(a.begin(), a.end());

    navigation_pile<element, container, ordering> 
      pq(n, less, b);
    for (position i = a.begin(); i != a.end(); ++i) {
      pq.push(*i); 
    }
  }
  void dual() {
    random_sequence(a.begin(), a.end());

    navigation_pile<element, container, ordering> 
      pq(n, less, b);
  }
private:
  unsigned int n;
  container a;
  container b;
  ordering less;
};

