#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n, unsigned int k) : n(n) {
    a = container(n, element(n));
    less = ordering();
  }
  void primal() {
    random_sequence(a.begin(), a.end());

    navigation_pile<element, container, ordering> 
      pq(n, less, a);
    int s = pq.size();
    while (s > 0) {
      pq.pop();
      s = s - 1;
    }
  }
  void dual() {
    random_sequence(a.begin(), a.end());
  }
private:
  unsigned int n;
  container a;
  ordering less;
};

