#include <queue> // defines std::priority_queue
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n, unsigned int k) : n(n) {
    d = container(3 * n, element());
    h = container();
    less = ordering();
  }
  void primal() {
    random_sequence(d.begin(), d.end());

    std::priority_queue<element, container, ordering> 
      pq(less, h);
    for (int i = 0; i < n; ++i) {
      e = d[2 * i];
      pq.push(e); 
      pq.pop();
      // now size i
      e = d[2 * i + 1];
      pq.push(e); 
      // now size i + 1
    }
    for (int i = n; i > 0; --i) {
      pq.pop();
      e = d[3 * n - i];
      pq.push(e); 
      // now size i
      pq.pop();
      // now size i - 1
    }
  }
  void dual() {
    // The same without pop() and push()
    random_sequence(d.begin(), d.end());

    std::priority_queue<element, container, ordering> 
      pq(less, h);
    for (int i = 0; i < n; ++i) {
      e = d[2 * i];
      e = d[2 * i + 1];
    }
    for (int i = n; i > 0; --i) {
      e = d[3 * n - i];
    }
  }
private:
  unsigned int n;
  container h; // PQ
  container d; // peak data
  ordering less;
  element e;
};

