#include <queue> // defines std::priority_queue
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n, unsigned int k) : n(n) {
    a = container(n, element());
    b = container(k, element());
    less = ordering();
  }
  void primal() {
    random_sequence(a.begin(), a.end());
    random_sequence(b.begin(), b.end());

    std::priority_queue<element, container, ordering> 
      pq(less, b);
    for (unsigned int i = 0; i < n; ++i) {
      e = a[i];
      pq.push(e); 
      pq.pop();
    }
  }
  void dual() {
    // The same without pop() and push()
    random_sequence(a.begin(), a.end());
    random_sequence(b.begin(), b.end());

    std::priority_queue<element, container, ordering> 
      pq(less, a);
    for (unsigned int i = 0; i < n; ++i) {
      e = a[i];
    }
  }
private:
  unsigned int n;
  container b; // PQ
  container a; // data
  ordering less;
  element e;
};

