import benchmark
import os
from benchmark_curve_case import *

class plot(benchmark.plot_suite):
  def __init__(self, element, log_i, log_k):
    benchmark.plot_suite.__init__(self)
    self.title = 'Efficiency of priority-queue operations: sort model, random bigints'
    self.xlabel = 'n'
    self.ylabel = 'Execution time per element [in nanoseconds]'
    x = (1 << log_i) - 10
    y = (1 << log_k) + 10
    self.gnuplot_commands += 'set key left top Left reverse samplen 4 spacing 1.25 title "" \n'
    self.gnuplot_commands += 'set xrange [' + str(x) + ':' + str(y) + ']'
#    self.add(gen_curve(element, 'pnp_queue_sort', 'Pointer_based_Navigation_piles', 'mixed pile', 'navigation_pile', log_i, log_k))
    self.add(gen_curve(element, 'pnp_queue_sort', 'Index_based_Navigation_piles', 'index pile', 'navigation_pile', log_i, log_k))
    self.add(gen_curve(element, 'pnp_queue_sort', 'Packed_Index_based_Navigation_piles', 'compact pile', 'navigation_pile', log_i, log_k))
    self.add(gen_curve(element, 'pnp_queue_sort', 'All_Pointer_based_Navigation_piles', 'pointer-based pile', 'navigation_pile', log_i, log_k))
#    self.add(gen_curve(element, 'pnp_queue_sort', 'All_Pointer_based_Navigation_piles_no_good', 'pointer-based no good pile', 'navigation_pile', log_i, log_k))
#    self.add(gen_curve(element, 'pnp_queue_sort', 'All_Pointer_based_Navigation_piles_no_leaf_vector', 'pointer-based no leaf vector pile', 'navigation_pile', log_i, log_k))
#    self.add(gen_curve(element, 'pnp_queue_sort', 'All_Pointer_based_Navigation_piles_no_tmp_vector', 'pointer-based no tmp vector pile', 'navigation_pile', log_i, log_k))
    self.add(gen_curve(element, 'bhr_queue_sort', 'Binary_heap_using_reference', 'referent heap', 'binary_heap_ref', log_i, log_k))
    self.add(std_curve(element, 'sgi_queue_sort', 'SGI', 'implicit heap', log_i, log_k))
    self.gnuplot_commands += """
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
set logscale x
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(
#    task = plot('bigint', 10, 10),
    task = plot('bigint', 10, 20),
    runner = benchmark.gnuplot_runner
  )
