#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include <functional> // defines std::less
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  int d,
  typename element, 
  typename ordering,
  typename container,
  typename position,
  typename policy
>
class experiment {
public:
  experiment(unsigned int n, unsigned int k) : n(n), k(k) {
    a = container(n, element());
    h = container(k, element());
    less = ordering();
  }

  void primal() {
    random_sequence(a.begin(), a.end());
    random_sequence_for_hold(h.begin(), h.end());
    for (unsigned int i = 0; i < n; ++i) {
      push_heap<d, position, ordering, policy>(a.begin(), a.begin() + i + 1, less);
    }
    for (unsigned int i = 0; i < k; ++i) {
      pop_heap<d, position, ordering, policy>(a.begin(), a.end(), less);
      a[n - 1] = a[n - 1] + h[i];
      push_heap<d, position, ordering, policy>(a.begin(), a.end(), less);
    }
  }

  void dual() {
    // The same without pop()'s and push()'s
    random_sequence(a.begin(), a.end());
    random_sequence_for_hold(h.begin(), h.end());
    for (unsigned int i = 0; i < n; ++i) {
    }
    for (unsigned int i = 0; i < k; ++i) {
      a[n - 1] = a[n - 1] + h[i];
    }
  }
private:
  unsigned int n;
  unsigned int k;
  container a; // heap
  container h; // hold data
  ordering less;
};

