import benchmark
import os
from benchmark_curve_case_hold import *

class sort_plot(benchmark.plot_suite):
  def __init__(self, element, log_i, log_k, k):
    benchmark.plot_suite.__init__(self)
    self.title = 'Efficiency of various sorting functions for random integers' 
    self.xlabel = 'n'
    self.ylabel = 'Execution time per element [in nanoseconds]'
    self.add(stdsort_curve(element, 'sander_hold_heap2', 'Sander', log_i, log_k, k))
    self.add(stdsort_curve(element, 'sander_hold_heap4', 'Sander', log_i, log_k, k))
#    self.add(stdsort_curve(element, 'sgi_heap_hold', 'SGI', log_i, log_k, k))
    self.gnuplot_commands += """
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
set logscale x
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(
    task = sort_plot('int', 10, 23, 1000000),
    runner = benchmark.gnuplot_runner
  )
