import benchmark
import os
from benchmark_curve_case import *

class sort_plot(benchmark.plot_suite):
  def __init__(self, element, log_i, log_k):
    benchmark.plot_suite.__init__(self)
    self.title = 'Efficiency of Sanders heap functions' 
    self.xlabel = 'n'
    self.ylabel = 'Execution time per element [in nanoseconds]'
    self.add(sandersort_curve(element, 'sander_insert_delete_heap2', 'Sander', log_i, log_k))
    self.add(sandersort_curve(element, 'sander_insert_delete_heap4', 'Sander', log_i, log_k))
#    self.add(stdsort_curve(element, 'sort', 'SGI', log_i, log_k))
#    self.add(stdsort_curve(element, 'sgi_queue_sort', 'SGI', log_i, log_k))
    self.gnuplot_commands += """
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
set logscale x
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(
    task = sort_plot('int', 10, 10),
    runner = benchmark.gnuplot_runner
  )
