#include <vector> // define std::vector
#include <iterator> // defines std::iterator_traits
#include <functional> // defines std::less
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

// I assume that the container is a vector or an array; see []'s

template <
  int a,
  typename element, 
  typename ordering,
  typename container,
  typename position,
  typename policy
>
class experiment {
public:
  experiment(unsigned int n) : n(n) {
    d = container(3 * n, element());
    h = container(n, element());
    less = ordering();
    p = policy(0);
  }

  void primal() {
    random_sequence(d.begin(), d.end());
    for (unsigned int i = 0; i < n; ++i) {
      h[i] = d[2 * i];
      push_heap<a, position, ordering, policy>(h.begin(), h.end(), less);
      pop_heap<a, position, ordering, policy>(h.begin(), h.end(), less);
      // now size i
      h[i] = d[2 * i + 1];
      push_heap<a, position, ordering, policy>(h.begin(), h.end(), less);
      // now size i + 1
    }
    for (int i = n; i > 0; --i) {
      pop_heap<a, position, ordering, policy>(h.begin(), h.end(), less);
      h[i - 1] = d[3 * n - i];
      push_heap<a, position, ordering, policy>(h.begin(), h.end(), less);
      // now size i
      pop_heap<a, position, ordering, policy>(h.begin(), h.end(), less);
      // now size i - 1
    }
  }

  void dual() {
    // The same without pop()'s and push()'s
    random_sequence(d.begin(), d.end());
    for (unsigned int i = 0; i < n; ++i) {
      h[i] = d[2 * i];
      h[i] = d[2 * i + 1];
    }
    for (int i = n; i > 0; --i) {
      h[i - 1] = d[3 * n - i];
    }
  }
private:
  unsigned int n;
  container h; // heap
  container d; // data
  ordering less;
  policy p;
};

