template <class Key, class Value>
struct KNElement {
  Key key; 
  Value value;
public:
  KNElement<Key, Value>(Key eka, Value toka) : key(eka), value(toka) {
  }
};

template<typename T>
class Key_less {
public:
  bool operator()(const T& a, const T& b) {
    return a.key < b.key;
  }
};


#include <queue> // defines std::priority_queue
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n) : n(n) {
    a = container(n, element(n));
    less = ordering();
  }
  void primal() {
    random_sequence(a.begin(), a.end());

    typedef KNElement<element, element> my_pair;

    std::priority_queue<my_pair, std::vector<my_pair>, Key_less<my_pair> > 
      q(Key_less<my_pair>(), std::vector<my_pair>());
    for (position i = a.begin(); i != a.end(); ++i) {
      element e = *i; element s = 0;
      my_pair p(e, s);
      q.push(p); 
    }
    int s = q.size();
    while (s > 0) {
      q.pop();
      s = s - 1;
    }
  }
  void dual() {
    random_sequence(a.begin(), a.end());
  }
private:
  unsigned int n;
  container a;
  ordering less;
};

