/*
Benchmark  the Cphstl heap_sort() function
*/

#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <
  typename element, 
  typename ordering,
  typename container,
  typename position
>
class experiment {
public:
  experiment(unsigned int n) : n(n) {
    a = container(n, element());
    less = ordering();
  }
  void primal() {
    random_sequence(a.begin(), a.end());
    make_dheap(a.begin(), a.end(), less);
    sort_dheap(a.begin(), a.end(), less);
  }
  void dual() {
    random_sequence(a.begin(), a.end());
    do_nothing<void, position, position, position, ordering>(a.begin(), a.end(), a.end(), less);
  }
private:
  unsigned int n;
  container a;
  ordering less;
};

