#ifndef __UTILITY_FUNCTIONS__
#define __UTILITY_FUNCTIONS__

#include <iostream>

template <int d, typename position, typename index, typename element, 
  typename ordering, typename policy>
void
sift_down(position a, index i, element x, const ordering& less, policy& p) {
  //std::cout << "before sift_down i,x: " << i << " " << x << std::endl;
  //show(a, a + p.size());

  index m = i;  
  index j = p.first_child(i);
  const index last_full_branch = p.parent(p.last_leaf() + 1) - 1;
  
  while (i <= last_full_branch) {
    j = p.top_all_present(a, i, less);
    p.update(a, i, a[j]);
    i = j;
  }
  
  j = p.first_child(i);
  if (j < p.size()) {
    j = p.top_some_absent(a, i, less);      
    p.update(a, i, a[j]);
    if (less(a[i], x)) {
      p.update(a, j, a[i]);
    }
    else {
      p.update(a, j, x);
      return;
    }
  }
  
  while ((i != m) && less(a[p.parent(i)], x)) {
    p.update(a, i, a[p.parent(i)]);
    i = p.parent(i);
  }
  p.update(a, i, x);
  
  //std::cout << "after sift_down: " << std::endl;
  //show(a, a + p.size());
} 

template <int d, typename position, typename index, typename element, 
  typename ordering, typename policy>
void
sift_up(position a, index j, element x, const ordering& less, policy& p) {
  //std::cout << "before sift_up j: " << j << std::endl;
  //show(a, a + p.size());

  while ((j != p.root()) && less(a[p.parent(j)], x)) {
    p.update(a, j, a[p.parent(j)]);
    j = p.parent(j);
  }
  p.update(a, j, x);
  
  //std::cout << "after sift_up" << std::endl;
  //show(a, a + p.size());
} 

#endif // __UTILITY_FUNCTIONS__


