#ifndef __debugging__
#define __debugging__

/*
Functions useful for debugging

Author: Jyrki Katajainen
Email: jyrki@diku.dk
Version: $Revision: 1.1 $
Date: $Date: 2003/10/29 23:14:46 $
*/

#include <iostream> // defines standard streams

template <typename input_iterator>
void show(input_iterator first, input_iterator one_past_the_end) {
  if (first == one_past_the_end) {
    std::cout << "{}" << std::endl;
    return;
  }
  std::cout << "{";
  for (input_iterator p = first; p < one_past_the_end - 1; ++p)
    std::cout <<  *p << ", ";
  for (input_iterator p = one_past_the_end - 1; p < one_past_the_end; ++p)
    std::cout << *p;
  std::cout << "}" << std::endl;
}

#endif // __debugging__


