/*
Benchmark for the partial_sort() function

Author: Jyrki Katajainen
Email: jyrki@diku.dk
$Revision: 1.3 $
$Date: 2003/01/26 15:54:24 $

*/

// Macro NAMESPACE must be defined on the command line
// The file defining NAMESPACE::partial_sort() must be included by the driver

#include <vector> // defines std::vector
#include "input_generation.c++" // defines random_sequence()
#include "do_nothing.c++" // defines do_nothing()

template <typename element>
class experiment {
public:
  experiment(unsigned int k, unsigned int n) : k(k) {
    a.resize(n);
  }
  void primal() {
    random_sequence(a.begin(), a.end());
    NAMESPACE::partial_sort(a.begin(), a.begin() + k, a.end());
  }
  void dual() {
    random_sequence(a.begin(), a.end());
    typedef typename std::vector<element>::iterator iterator;
    do_nothing<void, iterator, iterator, iterator>(a.begin(), a.begin() + k, a.end());
  }
private:
  unsigned int k;
  std::vector<element> a;
};

