#! /usr/bin/env python2.2
"""
This form has been automatically generated by the CPHSTL Benchmarking form generator.

This measures the relative cpu-time spent in the 'reduce' function during execution of the spin_benchmark program.
The benchmark is executed on the local host.
The output is returned in the form of a gnuplot.
"""

import benchmark
import string

class reducefunctime_case(benchmark.case):
  def __init__(self, n):
    benchmark.case.__init__(self)
    self.n = n
    self.counted_function = 'reduce'
    self.include_files.extend(['reduce_benchmark.c++'])
    self.constructor_call = 'spin(' + str(n) + ')'
    self.connection_protocol = 'rsh'
    self.transfer_protocol = 'rcp'
    self.driver_file = self.generate_function_call_count_driver()

  def output(self):
    return (self.n, string.split(self.driver_output)[0])

class reducefunctime_curve(benchmark.curve_suite):
  def __init__(self):
    benchmark.curve_suite.__init__(self)
    self.title = 'simple spin with function call'
    for k in range(100, 105 + 1):
      self.add(reducefunctime_case(k))

class reducefunctime_plot(benchmark.plot_suite):
  def __init__(self):
    benchmark.plot_suite.__init__(self)
    self.title = 'function spin'
    self.xlabel = 'n'
    self.ylabel = 'Percentage of total CPU-time spent in reduce'
    self.add(reducefunctime_curve())
    self.gnuplot_commands +="""
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(task = reducefunctime_plot(), runner = benchmark.gnuplot_runner)
