"""
Benchmarking the execution time of an empty loop

shell> echo $PYTHONPATH
/home/disk04/jyrki/CPHSTL/Tool/Benchmark/
"""

__author__ = "Jyrki Katajainen"
__email__ = "jyrki@diku.dk"
__version__ = "$Revision: 1.3 $"[11:-2]
__date__ = "$Date: 2003/06/08 15:43:15 $"[7:-2]

import benchmark
import os

class spin_case(benchmark.case):
  def __init__(self, n):
    benchmark.case.__init__(self)
    self.n = n
    self.computer = 'pc-014.diku.dk'
    self.compiler = '/scratch/g++3.0.4/bin/g++'
    self.compiler_options.extend(['-O3'])
    self.include_files.extend(['spin_benchmark.c++'])
    self.dual_exists = 0
    self.constructor_call = 'spin(' + str(n) + ')'
    self.time_unit = 'ns'
    self.driver_file = self.generate_cpu_time_driver()

  def output(self):
    return (self.n, float(self.driver_output) / self.n)

if __name__ == '__main__':
  benchmark.main(task = spin_case(1000000), runner = benchmark.text_runner)

