#! /usr/bin/env python2.2
"""
This form has been automatically generated by the CPHSTL Benchmarking form generator.

This measures the branch misprediction ratio of the spin_benchmark program.
The benchmark is executed on the local host.
The output is returned in the form of a gnuplot.
"""

import benchmark
import string

class spinbranch_case(benchmark.case):
  def __init__(self, n):
    benchmark.case.__init__(self)
    self.n = n
    self.papi_path = '/usr/local/papi'
    self.include_files.extend(['spin_benchmark.c++'])
    self.constructor_call = 'spin(' + str(n) + ')'
    self.connection_protocol = 'rsh'
    self.transfer_protocol = 'rcp'
    self.driver_file = self.generate_branch_misprediction_ratio_driver()

  def output(self):
    branch_miss = string.split(self.driver_output,";")[0]
    total_branch = string.split(self.driver_output,";")[1]
    result = float(branch_miss)/float(total_branch)
    return (self.n, result)

class spinbranch_curve(benchmark.curve_suite):
  def __init__(self):
    benchmark.curve_suite.__init__(self)
    self.title = 'simple spin'
    for k in range(100, 105 + 1):
      self.add(spinbranch_case(k))

class spinbranch_plot(benchmark.plot_suite):
  def __init__(self):
    benchmark.plot_suite.__init__(self)
    self.title = 'branch spin'
    self.xlabel = 'n'
    self.ylabel = 'Branch missprediction ratio'
    self.add(spinbranch_curve())
    self.gnuplot_commands +="""
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(task = spinbranch_plot(), runner = benchmark.gnuplot_runner)
