#! /usr/bin/env python2.2
"""
This form has been automatically generated by the CPHSTL Benchmarking form generator.

This measures the number of minor page faults during execution of the spin_benchmark program.
The benchmark is executed on the local host.
The output is returned in the form of a gnuplot.
"""

import benchmark
import string

class spinmem_case(benchmark.case):
  def __init__(self, n):
    benchmark.case.__init__(self)
    self.n = n
    self.papi_path = '/usr/local/papi'
    self.papitype = 'single'
    self.include_files.extend(['spin_benchmark.c++'])
    self.constructor_call = 'spin(' + str(n) + ')'
    self.connection_protocol = 'rsh'
    self.transfer_protocol = 'rcp'
    self.driver_file = self.generate_execution_mem_driver()

  def output(self):
    result = string.split(self.driver_output,";")[1]
    return (self.n, result)

class spinmem_curve(benchmark.curve_suite):
  def __init__(self):
    benchmark.curve_suite.__init__(self)
    self.title = 'simple spin'
    for k in range(100, 105 + 1):
      self.add(spinmem_case(k))

class spinmem_plot(benchmark.plot_suite):
  def __init__(self):
    benchmark.plot_suite.__init__(self)
    self.title = 'memory spin'
    self.xlabel = 'n'
    self.ylabel = 'Number of minor page faults'
    self.add(spinmem_curve())
    self.gnuplot_commands +="""
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(task = spinmem_plot(), runner = benchmark.gnuplot_runner)
