#! /usr/bin/env python2.2
"""
This form has been automatically generated by the CPHSTL Benchmarking form generator.

This measures the execution time of the spin_benchmark program.
The benchmark is executed on the local host.
The output is returned in the form of a gnuplot.
"""

import benchmark
import string

class localspin_case(benchmark.case):
  def __init__(self, n):
    benchmark.case.__init__(self)
    self.n = n
    self.compiler_options.extend(['-O3'])
    self.include_files.extend(['spin_benchmark.c++'])
    self.constructor_call = 'spin(' + str(n) + ')'
    self.connection_protocol = 'rsh'
    self.transfer_protocol = 'rcp'
    self.time_unit = 'ns'
    self.dual_exists = 0
    self.driver_file = self.generate_cpu_time_driver()

  def output(self):
    return (self.n, float(self.driver_output) / self.n)

class localspin_curve(benchmark.curve_suite):
  def __init__(self):
    benchmark.curve_suite.__init__(self)
    self.title = 'simple spin'
    for k in range(100, 105 + 1):
      self.add(localspin_case(k))

class localspin_plot(benchmark.plot_suite):
  def __init__(self):
    benchmark.plot_suite.__init__(self)
    self.title = 'local spin'
    self.xlabel = 'n'
    self.ylabel = 'Execution time per iteration [in ns]'
    self.add(localspin_curve())
    self.gnuplot_commands +="""
set title '%(title)s'
set xlabel '%(xlabel)s'
set ylabel '%(ylabel)s'
""" % self.__dict__

if __name__ == '__main__':
  benchmark.main(task = localspin_plot(), runner = benchmark.gnuplot_runner)
