#include <papi.h>
#include <sys/resource.h>

struct result{
long minpgf;
long majpgf;
long_long L1cmiss;
long_long L1cacc;
};

struct branchresult{
long_long BRmisp;
long_long BR;
};

template <typename functor>
int measure_page_primal_single(functor e,result *r){
  rusage usages;
  long  minPGFstart,minPGFend,majPGFstart,majPGFend;
  int retval;
  int Events[2] = {PAPI_L1_DCM,PAPI_L1_DCA};
  long_long values[2] = {};

      retval = PAPI_library_init(PAPI_VER_CURRENT);

	if (retval != PAPI_VER_CURRENT) {
		return -1; }
  
  getrusage(RUSAGE_SELF,&usages);
  minPGFstart=usages.ru_minflt;
  majPGFstart=usages.ru_majflt;
  if (PAPI_start_counters(Events,2)!=PAPI_OK) {
     return -2;
  }
  
  e.primal();

  if (PAPI_stop_counters(values,2)!=PAPI_OK) {
     return -3;
  }
  
  getrusage(RUSAGE_SELF,&usages);
  minPGFend=usages.ru_minflt;
  majPGFend=usages.ru_majflt;
  r->minpgf=minPGFend-minPGFstart;
  r->majpgf=(majPGFend-majPGFstart);
  r->L1cmiss=values[0];
  r->L1cacc=values[1];
  
  return 0;
}

template <typename functor>
int measure_page_primal_quad(functor e,result *r){
  rusage usages;
  long  minPGFstart,minPGFend,majPGFstart,majPGFend;
  int retval;
  int Events[2] = {PAPI_L1_DCM,PAPI_L1_DCA};
  long_long values[2] = {};

      retval = PAPI_library_init(PAPI_VER_CURRENT);

	if (retval != PAPI_VER_CURRENT) {
		return -1; }
  
  getrusage(RUSAGE_SELF,&usages);
  minPGFstart=usages.ru_minflt;
  majPGFstart=usages.ru_majflt;
  if (PAPI_start_counters(Events,2)!=PAPI_OK) {
     return -2;
  }
  
  e.primal();
  e.primal();
  e.primal();  
  e.primal();

  if (PAPI_stop_counters(values,2)!=PAPI_OK) {
     return -3;
  }
  
  getrusage(RUSAGE_SELF,&usages);
  minPGFend=usages.ru_minflt;
  majPGFend=usages.ru_majflt;
  r->minpgf=(minPGFend-minPGFstart)/4;
  r->majpgf=(majPGFend-majPGFstart)/4;
  r->L1cmiss=values[0]/4;
  r->L1cacc=values[1]/4;
  
  return 0;
}

template <typename functor>
int measure_page_primal_warmedup(functor e,result *r){
  rusage usages;
  long  minPGFstart,minPGFend,majPGFstart,majPGFend;
  int retval;
  int Events[2] = {PAPI_L1_DCM,PAPI_L1_DCA};
  long_long values[2] = {};

      retval = PAPI_library_init(PAPI_VER_CURRENT);

	if (retval != PAPI_VER_CURRENT) {
		return -1; }
  
  e.primal();
  getrusage(RUSAGE_SELF,&usages);
  minPGFstart=usages.ru_minflt;
  majPGFstart=usages.ru_majflt;
  if (PAPI_start_counters(Events,2)!=PAPI_OK) {
     return -2;
  }
  
  e.primal();
  
  if (PAPI_stop_counters(values,2)!=PAPI_OK) {
     return -3;
  }
  
  getrusage(RUSAGE_SELF,&usages);
  minPGFend=usages.ru_minflt;
  majPGFend=usages.ru_majflt;
  r->minpgf=minPGFend-minPGFstart;
  r->majpgf=majPGFend-majPGFstart;
  r->L1cmiss=values[0];
  r->L1cacc=values[1];
  
  return 0;
}

template <typename functor>
int measure_branch(functor e,branchresult *r){
  int retval;
  int Events[2] = {PAPI_BR_MSP,PAPI_BR_CN};
  long_long values[2] = {};

      retval = PAPI_library_init(PAPI_VER_CURRENT);

	if (retval != PAPI_VER_CURRENT) {
		return -1; }
  
   if (PAPI_start_counters(Events,2)!=PAPI_OK) {
     return -2;
  }
  
  e.primal();
  
  if (PAPI_stop_counters(values,2)!=PAPI_OK) {
     return -3;
  }
  
  r->BRmisp=values[0];
  r->BR=values[1];
  
  return 0;
}
